#!/usr/bin/env bash

FLAKE_DIR="/home/torjus/nixos"
NIXPKGS_DIR="/home/torjus/git/nixpkgs"

flake_metadata=$(nix flake metadata --json "$FLAKE_DIR" 2>/dev/null)

stable_input=$(echo "$flake_metadata" | jq '.locks.nodes.root.inputs.nixpkgs')
stable_rev=$(echo "$flake_metadata" | jq -r ".locks.nodes.$stable_input.locked.rev")
stable_branch=$(echo "$flake_metadata" | jq -r ".locks.nodes.$stable_input.original.ref")

unstable_input=$(echo "$flake_metadata" | jq '.locks.nodes.root.inputs."nixpkgs-unstable"')
unstable_rev=$(echo "$flake_metadata" | jq -r ".locks.nodes.$unstable_input.locked.rev")
unstable_branch=$(echo "$flake_metadata" | jq -r ".locks.nodes.$unstable_input.original.ref")

cd "$NIXPKGS_DIR" || exit 1
git fetch -q
git switch -q "$stable_branch"
git pull -q
stable_commit_count=$(git rev-list "$stable_rev..HEAD"|wc -l)
git switch -q "$unstable_branch"
git pull -q
unstable_commit_count=$(git rev-list "$unstable_rev..HEAD"|wc -l)

echo "$stable_commit_count|$unstable_commit_count"
